<?php
class smartlinkCrypto{
	private $api_key 	= "";		
	private $password 	= "";		
	
	private $amount 		= 0;	
	private $amountUSD 		= 0;		
	
	private $language		= "en";		
	
	private $orderID 		= "";		
	private $userID 		= "";		
	
	private $userFormat 	= "COOKIE"; 
	
	
	private $boxID			= 0; 		
	private $coinLabel		= ""; 		
	private $coinName		= ""; 		
	private $paid			= false;	
	private $confirmed		= false;	
	private $paymentID		= false;	
	private $paymentDate	= "";		
	private $amountPaid 	= 0;		
	
	private $boxType		= "";	
	private $processed		= false;
	private $localisation 	= "";		
	public $longname;
	public function __construct($options = array()) 
	{
		
		// Min requirements
		if (!function_exists( 'mb_stripos' ) || !function_exists( 'mb_strripos' ))  die(sprintf("Error. Please enable <a target='_blank' href='%s'>MBSTRING extension</a> in PHP. <a target='_blank' href='%s'>Read here &#187;</a>", "http://php.net/manual/en/book.mbstring.php", "http://www.knowledgebase-script.com/kb/article/how-to-enable-mbstring-in-php-46.html"));
		if (!function_exists( 'curl_init' )) 										die(sprintf("Error. Please enable <a target='_blank' href='%s'>CURL extension</a> in PHP. <a target='_blank' href='%s'>Read here &#187;</a>", "http://php.net/manual/en/book.curl.php", "http://stackoverflow.com/questions/1347146/how-to-enable-curl-in-php-xampp"));
		if (!function_exists( 'mysqli_connect' )) 									die(sprintf("Error. Please enable <a target='_blank' href='%s'>MySQLi extension</a> in PHP. <a target='_blank' href='%s'>Read here &#187;</a>", "http://php.net/manual/en/book.mysqli.php", "http://crybit.com/how-to-enable-mysqli-extension-on-web-server/"));
		if (version_compare(phpversion(), '5.4.0', '<')) 							die(sprintf("Error. You need PHP 5.4.0 (or greater). Current php version: %s", phpversion()));
		
	
		
		$this->smartlink_check_payment();
		
		return true;
	}
	
	public function smartlink_is_paid($remotedb = false)
	{
		if (!$this->paymentID && $remotedb) $this->smartlink_check_payment($remotedb);
		if ($this->paid) return true;
		else return false;
	}
	
	public function smartlink_is_confirmed()
	{
		if ($this->confirmed) return true;
		else return false;
	}
	
	public function smartlink_amount_paid()
	{
		if ($this->paid) return $this->amountPaid; 
		else return 0;
	}
	
	
	
	public function smartlink_payment_id()
	{
		return $this->paymentID;
	}
	
	public function smartlink_payment_info()
	{
		$obj = ($this->paymentID) ? run_sql_smartlink("SELECT * FROM smartlink_payments WHERE id = $this->paymentID LIMIT 1") : false;
		
		return $obj;
	}
	
	
    private function smartlink_check_payment($remotedb = false)
    {
    	static $already_checked = false;
    	
    	$this->paymentID = $diff = 0;
    	
    	$obj = run_sql_smartlink("SELECT * FROM smartlink_payments WHERE order_id = '$this->orderID' && user_id = '$this->userID'   DESC LIMIT 1");
    	
    	if ($obj)
    	{
    		$this->paymentID 		= $obj->id;
    		
    		$this->amountPaid 		= $obj->crypto_amount;
    		
    		$this->paid 			= true;
    		
    		
    	
    		
    	}
    	return true;
    }
}

function run_sql_smartlink($sql) {
    global $wpdb;

    $f = true;
    $g = $x = false;
    $res = array();

    $query = $wpdb->query($sql);
    if ($query === false) {
        die("MySQL Error: " . $wpdb->last_error . "; SQL: $sql");
    }

    if ($query) {
        foreach ($wpdb->last_result as $row) {
            if ($f) {
                if (property_exists($row, "idx")) $x = true;
                $c = count(get_object_vars($row));
                if ($c > 2 || ($c == 2 && !$x)) $g = true;
                elseif (!property_exists($row, "nme")) die("Error in run_sql_smartlink() - 'nme' not exists! SQL: $sql");
                $f = false;
            }

            if (!$g && $query == 1 && property_exists($row, "nme")) return $row->nme;
            elseif ($x) $res[$row->idx] = ($g) ? $row : $row->nme;
            else $res[] = ($g) ? $row : $row->nme;
        }
    } elseif (stripos($sql, "insert ") !== false) {
        $res = $wpdb->insert_id;
    }

    if (is_array($res) && count($res) == 1 && isset($res[0]) && is_object($res[0])) {
        $res = $res[0];
    }
    return $res;
}
// function run_sql_smartlink($sql)
// {
// 	global $mysqli;
	
// 	$f = true;
// 	$g = $x = false;
// 	$res = array();
	
	

//     $query = $mysqli->query($sql);  // re-run previous query
//     print_r($query);
//     die();
//     if ($query === FALSE) die("MySQL Error: ".$mysqli->error."; SQL: $sql");


//     if (is_object($query) && $query->num_rows)
//     {
//     	while($row = $query->fetch_object())
//     	{
//     		if ($f)
//     		{
//     			if (property_exists($row, "idx")) $x = true;
//     			$c = count(get_object_vars($row));
//     			if ($c > 2 || ($c == 2 && !$x)) $g = true;
//     			elseif (!property_exists($row, "nme")) die("Error in run_sql_smartlink() - 'nme' not exists! SQL: $sql");
//     			$f = false;
//     		}
    		
//     		if (!$g && $query->num_rows == 1 && property_exists($row, "nme")) return $row->nme;
//     		elseif ($x) $res[$row->idx] = ($g) ? $row : $row->nme;
//     		else $res[] = ($g) ? $row : $row->nme;
//     	}
//     }
//     elseif (stripos($sql, "insert ") !== false) $res = $mysqli->insert_id;

//     if (is_object($query)) $query->close();
//     if (is_array($res) && count($res) == 1 && isset($res[0]) && is_object($res[0])) $res = $res[0];
// 		return $res;
   
    
//     // en - English
  

//     // if ( ! defined('smartlink_CRYPTOBOX_LOCALISATION')) {
//     // 	define( 'smartlink_CRYPTOBOX_LOCALISATION', wp_json_encode($cryptobox_localisation_smartlink) );
//     // }
//     // unset($cryptobox_localisation_smartlink);
// }



?>